Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/file.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/file.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/file.f90	(revision 5075)
@@ -7,15 +7,23 @@
 !> @brief 
 !> This module manage file structure.
-!
+!>
 !> @details
-!>
 !>    define type TFILE:<br/>
-!>    TYPE(TFILE) :: tl_file<br/>
-!>
-!>    to initialise a file structure:<br/>
-!>    tl_file=file_init(cd_file [,cd_type] [,ld_wrt])
+!> @code
+!>    TYPE(TFILE) :: tl_file
+!> @endcode
+!>
+!>    to initialize a file structure:<br/>
+!> @code
+!>    tl_file=file_init(cd_file [,cd_type] [,ld_wrt] [,cd_grid])
+!%    tl_file=file_init(cd_file [,cd_type] [,ld_wrt] [,id_ew] [,id_perio] [,id_pivot] [,cd_grid])
+!> @endcode
 !>       - cd_file is the file name
-!>       - cd_type is the type of the file ('cdf', 'dimg') (optional)
-!>       - ld_wrt  file in write mode or not (optional)
+!>       - cd_type is the type of the file ('cdf', 'dimg') [optional]
+!>       - ld_wrt  file in write mode or not [optional]
+!%       - id_ew is the number of point for east-west overlap [optional]
+!%       - id_perio is the NEMO periodicity index [optional]
+!%       - id_pivot is the NEMO pivot point index F(0),T(1) [optional]
+!>       - cd_grid is the grid type (default 'ARAKAWA-C')
 !>
 !>    to get file name:<br/>
@@ -38,5 +46,5 @@
 !>    - tl_file\%i_nvar
 !>
-!>    to get the table of variable structure associated to the file:<br/>
+!>    to get the array of variable structure associated to the file:<br/>
 !>    - tl_file\%t_var(:)
 !>
@@ -45,5 +53,5 @@
 !>    - tl_file\%i_natt
 !>
-!>    to get the table of attributes structure associated to the file:<br/>
+!>    to get the array of attributes structure associated to the file:<br/>
 !>    - tl_file\%t_att(:)
 !>
@@ -52,49 +60,76 @@
 !>    - tl_file\%i_ndim
 !>
-!>    to get the table of dimension structure (4 elts) associated to the
+!>    to get the array of dimension structure (4 elts) associated to the
 !>    file:<br/>
 !>    - tl_file\%t_dim(:)
 !>
 !>    to print information about file structure:<br/>
+!> @code
 !>    CALL file_print(td_file)
+!> @endcode
+!>
+!>    to clean file structure:<br/>
+!> @code
+!>    CALL file_clean(td_file)
+!> @endcode
 !>
 !>    to add a global attribute structure in file structure:<br/>
+!> @code
 !>    CALL file_add_att(td_file, td_att)
+!> @endcode
 !>       - td_att is an attribute structure
 !>
 !>    to add a dimension structure in file structure:<br/>
+!> @code
 !>    CALL file_add_dim(td_file, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
 !>    to add a variable structure in file structure:<br/>
+!> @code
 !>    CALL file_add_var(td_file, td_var)
+!> @endcode
 !>       - td_var is a variable structure
 !>
 !>    to delete a global attribute structure in file structure:<br/>
+!> @code
 !>    CALL file_del_att(td_file, td_att)
+!> @endcode
 !>       - td_att is an attribute structure
 !>
 !>    to delete a dimension structure in file structure:<br/>
+!> @code
 !>    CALL file_del_dim(td_file, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
 !>    to delete a variable structure in file structure:<br/>
+!> @code
 !>    CALL file_del_var(td_file, td_var)
+!> @endcode
 !>       - td_var is a variable structure
 !>
 !>    to overwrite one attribute structure in file structure:<br/>
+!> @code
 !>    CALL file_move_att(td_file, td_att)
+!> @endcode
 !>       - td_att is an attribute structure
 !>
 !>    to  overwrite one dimension strucutre in file structure:<br/>
+!> @code
 !>    CALL file_move_dim(td_file, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
 !>    to overwrite one variable  structure in file structure:<br/>
+!> @code
 !>    CALL file_move_var(td_file, td_var)
+!> @endcode
 !>       - td_var is a variable structure
 !> 
 !>    to check if file and variable structure share same dimension:<br/>
+!> @code
 !>    ll_check_dim = file_check_var_dim(td_file, td_var)
+!> @endcode
 !>       - td_var is a variable structure
 !>
@@ -102,10 +137,8 @@
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013- Initial Version
+!> @date November, 2013- Initial Version
+!> @date November, 2014 - Fix memory leaks bug
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
-!> - file_get_var(td_file, varname)
-!> - add description generique de l'objet file
 !----------------------------------------------------------------------
 MODULE file
@@ -113,100 +146,107 @@
    USE global                          ! global variable
    USE fct                             ! basic useful function
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE dim                             ! dimension manager
    USE att                             ! attribute manager
    USE var                             ! variable manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! type and variable
-   PUBLIC :: TFILE   ! file structure
+   PUBLIC :: TFILE   !< file structure
 
    ! function and subroutine
-   PUBLIC :: ASSIGNMENT(=)   !< copy file structure
-   PUBLIC :: file_print      !< print information about file structure
-   PUBLIC :: file_clean      !< clean file structure
-   PUBLIC :: file_init       !< initialise file structure
-   PUBLIC :: file_add_att    !< add one attribute structure in file structure
-   PUBLIC :: file_add_var    !< add one variable  structure in file structure
-   PUBLIC :: file_add_dim    !< add one dimension strucutre in file structure
-   PUBLIC :: file_del_att    !< delete one attribute structure of file structure
-   PUBLIC :: file_del_var    !< delete one variable  structure of file structure
-   PUBLIC :: file_del_dim    !< delete one dimension strucutre of file structure
-   PUBLIC :: file_move_att   !< overwrite one attribute structure in file structure
-   PUBLIC :: file_move_var   !< overwrite one variable  structure in file structure
-   PUBLIC :: file_move_dim   !< overwrite one dimension strucutre in file structure
+   PUBLIC :: file_copy           !< copy file structure
+   PUBLIC :: file_print          !< print information about file structure
+   PUBLIC :: file_clean          !< clean file structure
+   PUBLIC :: file_init           !< initialize file structure
+   PUBLIC :: file_add_att        !< add one attribute structure in file structure
+   PUBLIC :: file_add_var        !< add one variable  structure in file structure
+   PUBLIC :: file_add_dim        !< add one dimension strucutre in file structure
+   PUBLIC :: file_del_att        !< delete one attribute structure of file structure
+   PUBLIC :: file_del_var        !< delete one variable  structure of file structure
+   PUBLIC :: file_del_dim        !< delete one dimension strucutre of file structure
+   PUBLIC :: file_move_att       !< overwrite one attribute structure in file structure
+   PUBLIC :: file_move_var       !< overwrite one variable  structure in file structure
+   PUBLIC :: file_move_dim       !< overwrite one dimension strucutre in file structure
    PUBLIC :: file_check_var_dim  !< check if file and variable structure use same dimension.
-   PUBLIC :: file_get_type   !< get type of file
-   PUBLIC :: file_get_id     !< get file id
-   PUBLIC :: file_rename     !< rename file name
-   PUBLIC :: file_add_suffix !< add suffix to file name
+   PUBLIC :: file_get_type       !< get type of file
+   PUBLIC :: file_get_id         !< get file id
+   PUBLIC :: file_rename         !< rename file name
+   PUBLIC :: file_add_suffix     !< add suffix to file name
  
-   PRIVATE :: file__del_var_name !< delete a variable structure in file structure, given variable name or standard name
-   PRIVATE :: file__del_var_str  !< delete a variable structure in file structure, given variable structure
-   PRIVATE :: file__del_att_name !< delete a attribute structure in file structure, given attribute name
-   PRIVATE :: file__del_att_str  !< delete a attribute structure in file structure, given attribute structure
-   PRIVATE :: file__get_number   !< get number in file name without suffix
-   PRIVATE :: file__get_suffix   !< get suffix of file name
-   PRIVATE :: file__copy_unit    !< copy file structure
-   PRIVATE :: file__copy_tab     !< copy file structure
-
-   !> @struct
-   TYPE TFILE
+   PRIVATE :: file__clean_unit    ! clean file structure
+   PRIVATE :: file__clean_arr     ! clean array of file structure
+   PRIVATE :: file__del_var_name ! delete a variable structure in file structure, given variable name or standard name
+   PRIVATE :: file__del_var_str  ! delete a variable structure in file structure, given variable structure
+   PRIVATE :: file__del_att_name ! delete a attribute structure in file structure, given attribute name
+   PRIVATE :: file__del_att_str  ! delete a attribute structure in file structure, given attribute structure
+   PRIVATE :: file__get_number   ! get number in file name without suffix
+   PRIVATE :: file__get_suffix   ! get suffix of file name
+   PRIVATE :: file__copy_unit    ! copy file structure
+   PRIVATE :: file__copy_arr     ! copy array of file structure
+   PRIVATE :: file__rename_char  ! rename file name, given processor number.
+   PRIVATE :: file__rename_str   ! rename file name, given file structure.
+
+   TYPE TFILE !< file structure
 
       ! general 
-      CHARACTER(LEN=lc)                 :: c_name = "" !< file name
-      CHARACTER(LEN=lc)                 :: c_type = "" !< type of the file (cdf, cdf4, dimg)
-      INTEGER(i4)                       :: i_id   = 0         !< file id
-      LOGICAL                           :: l_wrt  = .FALSE.   !< read or write mode
-      INTEGER(i4)                       :: i_nvar = 0         !< number of variable
-      TYPE(TVAR), DIMENSION(:), POINTER :: t_var  => NULL()   !< file variables
+      CHARACTER(LEN=lc)                 :: c_name = ""       !< file name
+      CHARACTER(LEN=lc)                 :: c_type = ""       !< type of the file (cdf, cdf4, dimg)
+      INTEGER(i4)                       :: i_id   = 0        !< file id
+      LOGICAL                           :: l_wrt  = .FALSE.  !< read or write mode
+      INTEGER(i4)                       :: i_nvar = 0        !< number of variable
+      TYPE(TVAR), DIMENSION(:), POINTER :: t_var  => NULL()  !< file variables
 
       CHARACTER(LEN=lc)                 :: c_grid = 'ARAKAWA-C' !< grid type
 
-      INTEGER(i4)                       :: i_ew    =-1   !< east-west overlap
-      INTEGER(i4)                       :: i_perio =-1   !< NEMO periodicity index
-      INTEGER(i4)                       :: i_pivot =-1   !< NEMO pivot point index F(0),T(1)
-
-      INTEGER(i4)                       :: i_depthid = 0         !< variable id of depth
-      INTEGER(i4)                       :: i_timeid  = 0         !< variable id of time
+      INTEGER(i4)                       :: i_ew    =-1       !< east-west overlap
+      INTEGER(i4)                       :: i_perio =-1       !< NEMO periodicity index
+      INTEGER(i4)                       :: i_pivot =-1       !< NEMO pivot point index F(0),T(1)
+
+      INTEGER(i4)                       :: i_depthid = 0     !< variable id of depth
+      INTEGER(i4)                       :: i_timeid  = 0     !< variable id of time
 
       ! netcdf file
-      INTEGER(i4)                       :: i_ndim  = 0        !< number of dimensions used in the file
-      INTEGER(i4)                       :: i_natt  = 0        !< number of global attributes in the file
-      INTEGER(i4)                       :: i_uldid = 0        !< id of the unlimited dimension in the file
-      LOGICAL                           :: l_def   = .FALSE.  !< define mode or not
-      TYPE(TATT), DIMENSION(:), POINTER :: t_att   => NULL()  !< global attributes
-      TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim              !< dimension structure
+      INTEGER(i4)                       :: i_ndim  = 0       !< number of dimensions used in the file
+      INTEGER(i4)                       :: i_natt  = 0       !< number of global attributes in the file
+      INTEGER(i4)                       :: i_uldid = 0       !< id of the unlimited dimension in the file
+      LOGICAL                           :: l_def   = .FALSE. !< define mode or not
+      TYPE(TATT), DIMENSION(:), POINTER :: t_att   => NULL() !< global attributes
+      TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim             !< dimension structure
       
       ! dimg file
-      INTEGER(i4)                       :: i_recl = 0         !< record length (binary file)
-      INTEGER(i4)                       :: i_n0d  = 0         !< number of scalar variable
-      INTEGER(i4)                       :: i_n1d  = 0         !< number of 1D variable
-      INTEGER(i4)                       :: i_n2d  = 0         !< number of 2D variable
-      INTEGER(i4)                       :: i_n3d  = 0         !< number of 3D variable
-      INTEGER(i4)                       :: i_rhd  = 0         !< record of the header infos (last record)
+      INTEGER(i4)                       :: i_recl = 0        !< record length (binary file)
+      INTEGER(i4)                       :: i_n0d  = 0        !< number of scalar variable
+      INTEGER(i4)                       :: i_n1d  = 0        !< number of 1D variable
+      INTEGER(i4)                       :: i_n2d  = 0        !< number of 2D variable
+      INTEGER(i4)                       :: i_n3d  = 0        !< number of 3D variable
+      INTEGER(i4)                       :: i_rhd  = 0        !< record of the header infos (last record)
 
       ! mpp
       ! only use for massively parallel processing
-      INTEGER(i4)                       :: i_pid  = -1        !< processor id (start to 1)
-      INTEGER(i4)                       :: i_impp = 0         !< i-indexes for mpp-subdomain left bottom
-      INTEGER(i4)                       :: i_jmpp = 0         !< j-indexes for mpp-subdomain left bottom
-      INTEGER(i4)                       :: i_lci  = 0         !< i-dimensions of subdomain
-      INTEGER(i4)                       :: i_lcj  = 0         !< j-dimensions of subdomain
-      INTEGER(i4)                       :: i_ldi  = 0         !< first indoor i-indices
-      INTEGER(i4)                       :: i_ldj  = 0         !< first indoor j-indices
-      INTEGER(i4)                       :: i_lei  = 0         !< last  indoor i-indices
-      INTEGER(i4)                       :: i_lej  = 0         !< last  indoor j-indices
-
-      LOGICAL                           :: l_ctr  = .FALSE.   !< domain is on border
-      LOGICAL                           :: l_use  = .FALSE.   !< domain is used
-
-      ! only use to draw domain decomposition when initialise with mpp_init
-      INTEGER(i4)                       :: i_iind = 0         !< i-direction indices
-      INTEGER(i4)                       :: i_jind = 0         !< j-direction indices
+      INTEGER(i4)                       :: i_pid  = -1       !< processor id (start to 1)
+      INTEGER(i4)                       :: i_impp = 0        !< i-indexes for mpp-subdomain left bottom
+      INTEGER(i4)                       :: i_jmpp = 0        !< j-indexes for mpp-subdomain left bottom
+      INTEGER(i4)                       :: i_lci  = 0        !< i-dimensions of subdomain
+      INTEGER(i4)                       :: i_lcj  = 0        !< j-dimensions of subdomain
+      INTEGER(i4)                       :: i_ldi  = 0        !< first indoor i-indices
+      INTEGER(i4)                       :: i_ldj  = 0        !< first indoor j-indices
+      INTEGER(i4)                       :: i_lei  = 0        !< last  indoor i-indices
+      INTEGER(i4)                       :: i_lej  = 0        !< last  indoor j-indices
+
+      LOGICAL                           :: l_ctr  = .FALSE.  !< domain is on border
+      LOGICAL                           :: l_use  = .FALSE.  !< domain is used
+
+      ! only use to draw domain decomposition when initialize with mpp_init
+      INTEGER(i4)                       :: i_iind = 0        !< i-direction indices
+      INTEGER(i4)                       :: i_jind = 0        !< j-direction indices
 
    END TYPE TFILE
+
+   INTERFACE file_clean
+      MODULE PROCEDURE file__clean_unit
+      MODULE PROCEDURE file__clean_arr
+   END INTERFACE file_clean
 
    INTERFACE file_del_var
@@ -225,7 +265,7 @@
    END INTERFACE file_rename
 
-    INTERFACE ASSIGNMENT(=)
-      MODULE PROCEDURE file__copy_unit   ! copy file structure
-      MODULE PROCEDURE file__copy_tab    ! copy file structure
+    INTERFACE file_copy
+      MODULE PROCEDURE file__copy_unit   
+      MODULE PROCEDURE file__copy_arr    
    END INTERFACE
 
@@ -233,8 +273,7 @@
    !-------------------------------------------------------------------
    !> @brief
-   !> This function copy file structure in another file
-   !> structure
+   !> This subroutine copy file structure in another one
    !> @details 
-   !> file variable and attribute value are copied in a temporary table, 
+   !> file variable and attribute value are copied in a temporary array, 
    !> so input and output file structure value do not point on the same 
    !> "memory cell", and so on are independant. 
@@ -242,19 +281,29 @@
    !> @note new file is assume to be closed.
    !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_file=file_copy(file_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>   
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_file1  : file structure
-   !> @param[in] td_file2  : file structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE file__copy_unit( td_file1, td_file2 )
+   !> - November, 2013- Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
+   !
+   !> @param[in] td_file  file structure
+   !> @return copy of input file structure
+   !-------------------------------------------------------------------
+   FUNCTION file__copy_unit( td_file )
       IMPLICIT NONE
       ! Argument
-      TYPE(TFILE), INTENT(  OUT) :: td_file1
-      TYPE(TFILE), INTENT(IN   )  :: td_file2
+      TYPE(TFILE), INTENT(IN) :: td_file
+      ! function
+      TYPE(TFILE) :: file__copy_unit
+
+      ! local variable
+      TYPE(TVAR) :: tl_var
+      TYPE(TATT) :: tl_att
 
       ! loop indices
@@ -262,78 +311,90 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace("COPY: file "//TRIM(td_file2%c_name) )
+      CALL logger_trace("FILE COPY: file "//TRIM(td_file%c_name) )
 
       ! copy file variable
-      td_file1%c_name = TRIM(td_file2%c_name)
-      td_file1%c_type = TRIM(td_file2%c_type)
+      file__copy_unit%c_name = TRIM(td_file%c_name)
+      file__copy_unit%c_type = TRIM(td_file%c_type)
       ! file1 should be closed even if file2 is opened right now
-      td_file1%i_id   = 0
-      td_file1%l_wrt  = td_file2%l_wrt
-      td_file1%i_nvar = td_file2%i_nvar
-
-      td_file1%c_grid = td_file2%c_grid
-
-      td_file1%i_ew   = td_file2%i_ew
-      td_file1%i_perio= td_file2%i_perio
-      td_file1%i_pivot= td_file2%i_pivot
+      file__copy_unit%i_id   = 0
+      file__copy_unit%l_wrt  = td_file%l_wrt
+      file__copy_unit%i_nvar = td_file%i_nvar
+
+      file__copy_unit%c_grid = td_file%c_grid
+
+      file__copy_unit%i_ew   = td_file%i_ew
+      file__copy_unit%i_perio= td_file%i_perio
+      file__copy_unit%i_pivot= td_file%i_pivot
+
+      file__copy_unit%i_depthid = td_file%i_depthid
+      file__copy_unit%i_timeid  = td_file%i_timeid
 
       ! copy variable structure
-      IF( ASSOCIATED(td_file1%t_var) ) DEALLOCATE(td_file1%t_var)
-      IF( ASSOCIATED(td_file2%t_var) .AND. td_file1%i_nvar > 0 )THEN
-         ALLOCATE( td_file1%t_var(td_file1%i_nvar) )
-         DO ji=1,td_file1%i_nvar
-            td_file1%t_var(ji) = td_file2%t_var(ji)
+      IF( ASSOCIATED(file__copy_unit%t_var) )THEN
+         CALL var_clean(file__copy_unit%t_var(:))
+         DEALLOCATE(file__copy_unit%t_var)
+      ENDIF
+      IF( ASSOCIATED(td_file%t_var) .AND. file__copy_unit%i_nvar > 0 )THEN
+         ALLOCATE( file__copy_unit%t_var(file__copy_unit%i_nvar) )
+         DO ji=1,file__copy_unit%i_nvar
+            tl_var = var_copy(td_file%t_var(ji))
+            file__copy_unit%t_var(ji) = var_copy(tl_var)
          ENDDO
       ENDIF
       
       ! copy netcdf variable
-      td_file1%i_ndim    = td_file2%i_ndim
-      td_file1%i_natt    = td_file2%i_natt
-      td_file1%i_uldid   = td_file2%i_uldid
-      td_file1%l_def     = td_file2%l_def
+      file__copy_unit%i_ndim   = td_file%i_ndim
+      file__copy_unit%i_natt   = td_file%i_natt
+      file__copy_unit%i_uldid  = td_file%i_uldid
+      file__copy_unit%l_def    = td_file%l_def
 
       ! copy dimension
-      td_file1%t_dim(:) = td_file2%t_dim(:)
+      file__copy_unit%t_dim(:) = dim_copy(td_file%t_dim(:))
       
       ! copy attribute structure
-      IF( ASSOCIATED(td_file1%t_att) ) DEALLOCATE(td_file1%t_att)
-      IF( ASSOCIATED(td_file2%t_att) .AND. td_file1%i_natt > 0 )THEN
-         ALLOCATE( td_file1%t_att(td_file1%i_natt) )
-         DO ji=1,td_file1%i_natt
-            td_file1%t_att(ji) = td_file2%t_att(ji)
+      IF( ASSOCIATED(file__copy_unit%t_att) )THEN
+         CALL att_clean(file__copy_unit%t_att(:))
+         DEALLOCATE(file__copy_unit%t_att)
+      ENDIF
+      IF( ASSOCIATED(td_file%t_att) .AND. file__copy_unit%i_natt > 0 )THEN
+         ALLOCATE( file__copy_unit%t_att(file__copy_unit%i_natt) )
+         DO ji=1,file__copy_unit%i_natt
+            tl_att = att_copy(td_file%t_att(ji))
+            file__copy_unit%t_att(ji) = att_copy(tl_att)
          ENDDO
       ENDIF
 
+      ! clean
+      CALL att_clean(tl_att)
+
       ! copy dimg variable
-      td_file1%i_recl = td_file2%i_recl
-      td_file1%i_n0d  = td_file2%i_n0d
-      td_file1%i_n1d  = td_file2%i_n1d
-      td_file1%i_n2d  = td_file2%i_n2d
-      td_file1%i_n3d  = td_file2%i_n3d 
-      td_file1%i_rhd  = td_file2%i_rhd
+      file__copy_unit%i_recl = td_file%i_recl
+      file__copy_unit%i_n0d  = td_file%i_n0d
+      file__copy_unit%i_n1d  = td_file%i_n1d
+      file__copy_unit%i_n2d  = td_file%i_n2d
+      file__copy_unit%i_n3d  = td_file%i_n3d 
+      file__copy_unit%i_rhd  = td_file%i_rhd
       
       ! copy mpp variable
-      td_file1%i_pid  = td_file2%i_pid
-      td_file1%i_impp = td_file2%i_impp
-      td_file1%i_jmpp = td_file2%i_jmpp
-      td_file1%i_lci  = td_file2%i_lci
-      td_file1%i_lcj  = td_file2%i_lcj
-      td_file1%i_ldi  = td_file2%i_ldi
-      td_file1%i_ldj  = td_file2%i_ldj
-      td_file1%i_lei  = td_file2%i_lei
-      td_file1%i_lej  = td_file2%i_lej
-      td_file1%l_ctr  = td_file2%l_ctr
-      td_file1%l_use  = td_file2%l_use
-      td_file1%i_iind = td_file2%i_iind
-      td_file1%i_jind = td_file2%i_jind
-
-   END SUBROUTINE file__copy_unit
-   !> @endcode
+      file__copy_unit%i_pid  = td_file%i_pid
+      file__copy_unit%i_impp = td_file%i_impp
+      file__copy_unit%i_jmpp = td_file%i_jmpp
+      file__copy_unit%i_lci  = td_file%i_lci
+      file__copy_unit%i_lcj  = td_file%i_lcj
+      file__copy_unit%i_ldi  = td_file%i_ldi
+      file__copy_unit%i_ldj  = td_file%i_ldj
+      file__copy_unit%i_lei  = td_file%i_lei
+      file__copy_unit%i_lej  = td_file%i_lej
+      file__copy_unit%l_ctr  = td_file%l_ctr
+      file__copy_unit%l_use  = td_file%l_use
+      file__copy_unit%i_iind = td_file%i_iind
+      file__copy_unit%i_jind = td_file%i_jind
+
+   END FUNCTION file__copy_unit
    !-------------------------------------------------------------------
    !> @brief
-   !> This function copy file structure in another file
-   !> structure
+   !> This subroutine copy a array of file structure in another one
    !> @details 
-   !> file variable and attribute value are copied in a temporary table, 
+   !> file variable and attribute value are copied in a temporary array, 
    !> so input and output file structure value do not point on the same 
    !> "memory cell", and so on are independant. 
@@ -341,19 +402,25 @@
    !> @note new file is assume to be closed.
    !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_file=file_copy(file_init()) is forbidden).
+   !> This will create memory leaks.
    !> @warning to avoid infinite loop, do not use any function inside 
    !> this subroutine
    !>   
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_file1  : file structure
-   !> @param[in] td_file2  : file structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE file__copy_tab( td_file1, td_file2 )
+   !> - November, 2013- Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
+   !
+   !> @param[in] td_file  file structure
+   !> @return copy of input array of file structure
+   !-------------------------------------------------------------------
+   FUNCTION file__copy_arr( td_file )
       IMPLICIT NONE
       ! Argument
-      TYPE(TFILE), DIMENSION(:)                , INTENT(IN   )  :: td_file2
-      TYPE(TFILE), DIMENSION(SIZE(td_file2(:))), INTENT(  OUT) :: td_file1
+      TYPE(TFILE), DIMENSION(:)                , INTENT(IN   ) :: td_file
+      ! function
+      TYPE(TFILE), DIMENSION(SIZE(td_file(:))) :: file__copy_arr
 
       ! loop indices
@@ -361,26 +428,35 @@
       !----------------------------------------------------------------
 
-      DO ji=1,SIZE(td_file2(:))
-         td_file1(ji)=td_file2(ji)
+      DO ji=1,SIZE(td_file(:))
+         file__copy_arr(ji)=file_copy(td_file(ji))
       ENDDO
 
-   END SUBROUTINE file__copy_tab
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function initialise file structure.<br/>
+   END FUNCTION file__copy_arr
+   !-------------------------------------------------------------------
+   !> @brief This function initialize file structure.<br/> 
+   !> @details
    !> If cd_type is not specify, check if file name include '.nc' or
-   !> .'dimg'<br/>
+   !> '.dimg'<br/>
+   !> Optionally, you could specify:<br/>
+   !> - write mode (default .FALSE., ld_wrt)
+   !% - East-West overlap (id_ew)
+   !% - NEMO periodicity index (id_perio)
+   !% - NEMO pivot point index F(0),T(1) (id_pivot)
+   !> - grid type (default: 'ARAKAWA-C')
    !
    !> @details
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_file : file name
-   !> @param[in] cd_type : file type ('cdf', 'dimg')
-   !> @param[in] ld_wrt  : write mode (default .FALSE.)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_file   file name
+   !> @param[in] cd_type   file type ('cdf', 'dimg')
+   !> @param[in] ld_wrt    write mode (default .FALSE.)
+   !> @param[in] id_ew     east-west overlap
+   !> @param[in] id_perio  NEMO periodicity index
+   !> @param[in] id_pivot  NEMO pivot point index F(0),T(1)
+   !> @param[in] cd_grid   grid type (default 'ARAKAWA-C')
    !> @return file structure
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TFILE) FUNCTION file_init( cd_file, cd_type, ld_wrt, &
    &                               id_ew, id_perio, id_pivot,&
@@ -397,5 +473,5 @@
 
       ! local variable
-      TYPE(TATT) :: tl_att
+      TYPE(TATT)  :: tl_att
       !----------------------------------------------------------------
 
@@ -404,12 +480,5 @@
 
       file_init%c_name=TRIM(ADJUSTL(cd_file))
-      CALL logger_trace("INIT: initialise file "//TRIM(file_init%c_name))
-
-      ! create some global attribute
-      tl_att=att_init("Conventions","CF-1.5")
-      CALL file_add_att(file_init,tl_att)
-     
-      tl_att=att_init("Grid",TRIM(file_init%c_grid))
-      CALL file_add_att(file_init,tl_att)
+      CALL logger_trace("FILE INIT: initialize file "//TRIM(file_init%c_name))
 
       ! check type
@@ -421,5 +490,5 @@
                file_init%c_type='dimg'
             CASE DEFAULT
-               CALL logger_error( " INIT: can't initialise file "//&
+               CALL logger_error( " FILE INIT: can't initialize file "//&
                &               TRIM(file_init%c_name)//" : type unknown " )
          END SELECT
@@ -427,4 +496,13 @@
          file_init%c_type=TRIM(file_get_type(cd_file))
       ENDIF
+
+      ! create some global attribute
+      IF( TRIM(file_init%c_type) == 'cdf' )THEN
+         tl_att=att_init("Conventions","CF-1.5")
+         CALL file_add_att(file_init,tl_att)
+      ENDIF
+     
+      tl_att=att_init("Grid",TRIM(file_init%c_grid))
+      CALL file_add_att(file_init,tl_att)
 
       IF( PRESENT(ld_wrt) )THEN
@@ -460,6 +538,8 @@
       ENDIF
 
+      ! clean
+      CALL att_clean(tl_att)
+
    END FUNCTION file_init
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
@@ -473,14 +553,14 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_file : file name
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_file   file name
    !> @return type of file
    !-------------------------------------------------------------------
-   !> @code
    CHARACTER(LEN=lc) FUNCTION file_get_type(cd_file)
       IMPLICIT NONE
       ! Argument      
       CHARACTER(LEN=*), INTENT(IN) :: cd_file
+
       !local variable
       CHARACTER(LEN=lc) :: cl_suffix
@@ -490,11 +570,11 @@
       SELECT CASE( TRIM(fct_lower(cl_suffix)) )
          CASE('.nc','.cdf')
-            CALL logger_debug(" GET TYPE: file "//TRIM(cd_file)//" is cdf")
+            CALL logger_debug(" FILE GET TYPE: file "//TRIM(cd_file)//" is cdf")
             file_get_type='cdf'
          CASE('.dimg')
-            CALL logger_debug(" GET TYPE: file "//TRIM(cd_file)//" is dimg" )
+            CALL logger_debug(" FILE GET TYPE: file "//TRIM(cd_file)//" is dimg" )
             file_get_type='dimg'
          CASE DEFAULT
-            CALL logger_warn(" GET TYPE: type unknown, we assume file: "//&
+            CALL logger_warn(" FILE GET TYPE: type unknown, we assume file: "//&
             &              TRIM(cd_file)//" is dimg ")
             file_get_type='dimg'
@@ -502,5 +582,4 @@
 
    END FUNCTION file_get_type
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function check if variable dimension to be used 
@@ -510,11 +589,10 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] td_var : variable structure
-   !> @return dimension of variable and file structure agree (or not)
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] td_var    variable structure
+   !> @return true if dimension of variable and file structure agree
+   !-------------------------------------------------------------------
    LOGICAL FUNCTION file_check_var_dim(td_file, td_var)
       IMPLICIT NONE
@@ -524,5 +602,8 @@
 
       ! local variable
-      INTEGER(i4) :: il_ndim
+      CHARACTER(LEN=lc) :: cl_dim
+      LOGICAL           :: ll_error
+
+      INTEGER(i4) :: il_ind
 
       ! loop indices
